
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "display.h"
#include "docparse.h"
#include "links.h"
#include "toc.h"

#include "main.h"
 typedef struct hent {
	struct hent *prev,*next;
	char *name;
} histent_t;
 static  page_t *
make_default_doc() ; static  page_t* get_default_page(page_t *pages) ; static  void goto_page(char *tgt) ; static  page_t *find_page(char *name) ; static  void set_node_name(char *name) ; static  void load_file_nodisplay(char *fname) ; static  void set_string(char **str,char *val) ; static  void history_push(char *name) ;
 static  page_t *pageset;
static char default_doc[]= 
"=== Main Page ==="
"\n\n"
"This is the main page of your document. Edit this page to add your own content." 
;
 static  char *node_name; static  char *file_name;
static histent_t history_store= {&history_store, &history_store};
static histent_t *history = &history_store;






int main(int argc,char **argv) {
	
	page_t *p;
	if (argc>1) 
		load_file_nodisplay(argv[1]);
	if (!pageset)
		pageset= make_default_doc();
	p= get_default_page(pageset);
	get_link_targets(p->text);
	init_display(p->name,p->text);
	set_node_name(p->name);
	history_push(p->name);
	run_gui();
	return 0;
}










	

 static  page_t *
make_default_doc() {
	page_t *root;
	page_t *p;
	
	root= (typeof(root)) calloc(1, sizeof(root[0]));


	root->prev= root->next= root;
	
	p= (typeof(p)) calloc(1, sizeof(p[0]));


	p->text= strdup(default_doc);
	p->name= strdup("main");
	 {
	(p)->prev= (root)->prev; 
	(p)->next= (root); 
	(root)->prev->next= (p); 
	(root)->prev= (p); 
}


	return root;
}

 static  page_t* get_default_page(page_t *pages) {
	page_t *p;
	p= find_page("main");
	if (p)
		return p;
	else
		return pages->next;
}

 void follow_link(int id) {
	char *tgt;
	
	tgt= link_text(id);
	if (!tgt)
		return ;
	history_push(tgt);
	goto_page(tgt);
}

 static  void goto_page(char *tgt) {
	page_t *p;
	p= find_page(tgt);
	if (p) {
		display_text(tgt,p->text);
		set_node_name(p->name);
		get_link_targets(p->text);
	} else {
		char buf[2000];
		sprintf(buf,"The page %s does not exist in the document.\n\n"
			"In order to create it, edit this page and then save.", tgt);
		display_text(tgt,buf);
		set_node_name(tgt);
		get_link_targets(buf);
	}
}

 static  page_t *find_page(char *name) {
	page_t *p;
	  {
	void *N17;
	for(p=pageset->next;p!=pageset;p=N17)  {
		N17= p->next;

		if (!strcmp(p->name,name))
			return p;
	
    } }


	return 0;
}

 static  void set_node_name(char *name) {
	
	if (node_name)
		free(node_name);
	node_name= strdup(name);
}



 void save_page(char *name,char *text) {
	page_t *p;
	p= find_page(name);
	if (p) {
		free(p->text);
		p->text= strdup(text);
	} else {
		
	p= (typeof(p)) calloc(1, sizeof(p[0]));


		p->name= strdup(name);
		p->text= strdup(text);
		 {
	(p)->prev= (pageset)->prev; 
	(p)->next= (pageset); 
	(pageset)->prev->next= (p); 
	(pageset)->prev= (p); 
}


	}
	set_node_name(name);
	display_text(p->name, p->text);
	get_link_targets(p->text);
}

 static  void load_file_nodisplay(char *fname) {
	page_t *p;
	set_string(&file_name,fname);
	if (pageset) {
		  {
	void *N26;
	for(p=pageset->next;p!=pageset;p=N26)  {
		N26= p->next;

			free(p->name);
			free(p->text);
			 {
	(p)->prev->next= (p)->next; 
	(p)->next->prev= (p)->prev; 
}


			free(p);
		
    } }


		free(pageset);
	}
	pageset= read_doc(fname);
	if (!pageset)
		pageset= make_default_doc();
}

 void load_file(char* fname) {
	page_t *p;
	
	load_file_nodisplay(fname);
	p= get_default_page(pageset);
	get_link_targets(p->text);
	display_text(p->name, p->text);
}

 static  void set_string(char **str,char *val) {
	if (*str!=val) {
		if (*str)
			free(*str);
		*str= strdup(val);
	}
}

 char* get_file_name() { return file_name ? strdup(file_name) : 0 ; }

 void save_file(char *fname) {
	if (save_doc(fname,pageset))
		return ;
	set_string(&file_name,fname);
}

 void move_back() {
	histent_t *p;
	p= history->prev;
	if (p==&history_store)
		return ;
	history= p;
	goto_page(p->name);
}

 void move_forward() {
	histent_t *p;
	p= history->next;
	if (p==&history_store)
		return ;
	history= p;
	goto_page(p->name);
}

 static  void history_push(char *name) {
	histent_t *p,*N;
	for(p=history->next;p!=&history_store;p=N) {
		N= p->next;
		 {
	(p)->prev->next= (p)->next; 
	(p)->next->prev= (p)->prev; 
}


		free(p->name);
		free(p);
	}
	
	p= (typeof(p)) calloc(1, sizeof(p[0]));


	p->name= strdup(name);
	 {
	(p)->prev= ((&history_store))->prev; 
	(p)->next= ((&history_store)); 
	((&history_store))->prev->next= (p); 
	((&history_store))->prev= (p); 
}


	history= p;
}






 void display_toc() {
	char *text;
	text= gen_toc(pageset);
	display_text(":history", text);
	get_link_targets(text);
	free(text);
}

