
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "docparse.h"

#include "toc.h"
 typedef struct plist {
	struct plist *prev,*next;
	char *name;
} plist_t;
 static  char *format_page_list(char *title,plist_t *p) ; static  int make_page_array(plist_t *L,char **buf) ; static  int format_page_array
		(char *title, char **parray,int plen,char *buf,int off)
; static  int format_pages
		(char **parray,int plen, char *buf,int off, int level,int noff)
; static  int common(char *x1,char *x2,int prev) ; static  char *get_pfx(char *str,int pfx) ; static  int append_buffer(char *buf,char *val,int off) ; static  void rep_char(char *abuf, int chr,int len) ; static  int is_child(char *candidate,char *base) ;

	static void quicksort_34(char* *A, int left, int right) {
		if (right<=left)
			return ;
		/* pivot position */
		int ppos=left;
		int i;
		for(i=left;i<right;i++) {
			/* this will have the effect of no-sort
			if a comparision is not given */
			int result=-1;
			char*  *X1= A+i;
			char* *X2= A+right;
			

			result= strcmp(*X1, *X2);
	

			if (result<=0) {
				char* V1= A[i];
				A[i]= A[ppos];
				A[ppos]= V1;
				ppos++;
			}
		}
		{
			char* V2= A[ppos];
			A[ppos]= A[right];
			A[right]= V2;
		}
		quicksort_34(A, left, ppos-1);
		quicksort_34(A, ppos+1, right);
	}

		










 char *gen_toc(page_t *L) {
	plist_t PL;
	page_t *p;
	char *ret;
	plist_t *e;

	PL.prev= PL.next= &PL;
	  {
	void *N7;
	for(p=L->next;p!=L;p=N7)  {
		N7= p->next;

		
	e= (typeof(e)) calloc(1, sizeof(e[0]));


		e->name= p->name;
		 {
	(e)->prev= ((&PL))->prev; 
	(e)->next= ((&PL)); 
	((&PL))->prev->next= (e); 
	((&PL))->prev= (e); 
}


	
    } }


	ret= format_page_list("İçindekiler", &PL);
	  {
	void *N11;
	for(e=(&PL)->next;e!=(&PL);e=N11)  {
		N11= e->next;

		 {
	(e)->prev->next= (e)->next; 
	(e)->next->prev= (e)->prev; 
}


		free(e);
	
    } }


	return ret;
}




 static  char *format_page_list(char *title,plist_t *p) {
	char *ret;
	int len;
	
	char **parray;
	int plen;
	plen= make_page_array(p, 0);
	 
	parray= (typeof(parray)) calloc(plen, sizeof(parray[0]));


	make_page_array(p,parray);


	
	
	quicksort_34(parray, 0,plen-1);



		

	len= format_page_array(title, parray, plen, 0, 0);
	ret= malloc(len+1);
	format_page_array(title, parray, plen, ret, 0);
	ret[len]= 0;
	free(parray);
	return ret;
}



 static  int make_page_array(plist_t *L,char **buf) {
	plist_t *p;
	int len=0;
	  {
	void *N19;
	for(p=L->next;p!=L;p=N19)  {
		N19= p->next;

		if (buf)
			buf[len]= p->name;
		len++;
	
    } }


	return len;
		
}

 static  int format_page_array
		(char *title, char **parray,int plen,char *buf,int off)
{
	char tbuf[200];
	sprintf(tbuf,"=== %s ===\n\n", title);
	off= append_buffer(buf, tbuf,off);
	return format_pages(parray, plen, buf, off, 0,0);
}

 static  int format_pages
		(char **parray,int plen, char *buf,int off, int level,int noff)
{
	int i;
	i= 0;

	while(i<plen) {
		char xbuf[1000];
		char abuf[100];
		int cs,ce;
		cs= i+1;
		if (cs<plen && is_child(parray[cs],parray[i])) {
			int common_pfx= strlen(parray[cs]);
			for(ce=cs;ce<plen;ce++)
				if (is_child(parray[ce], parray[i]))
					common_pfx= common( parray[ce],  parray[cs],
							common_pfx);
				else
					break;
			rep_char(abuf, '+', level+1);

			sprintf(xbuf,"%s X<%s>L<%s>\n", abuf, parray[i],
				get_pfx(parray[i],common_pfx)+noff);
			off= append_buffer(buf,xbuf,off);
			off = format_pages(parray+cs, ce-cs,
				buf, off,
				level+1,  common_pfx+1);
			i= ce;
		} else {
			rep_char(abuf,'+', level+1);
			sprintf(xbuf,"%s X<%s>L<%s>\n", abuf, parray[i], parray[i]+noff);
			off= append_buffer(buf,xbuf,off);
			i++;
		}
	}
	return off;
}


/* a.b.c  a.b.d  -> L(a.b.) */
 static  int common(char *x1,char *x2,int prev) {
	int i;
	if (strlen(x2)<strlen(x1)) {
		char *t= x2;
		x2= x1;
		x1= t;
	}
	for(i=0;x1[i];i++)
		if (x1[i]!=x2[i])
			break;
	if (x1[i]) 
		while(i && x1[i]!='.') i--;
	if (i<prev)
		return i;
	else
		return prev;
}

/* WARNING: not re-entrant. returns a static buffer */
 static  char *get_pfx(char *str,int pfx) {
	static char buf[2000];
	memcpy(buf,str,pfx);
	buf[pfx]= 0;
	return buf;
}



 static  int append_buffer(char *buf,char *val,int off) {
	int L= strlen(val);
	if (buf) 
		memcpy(buf+off, val, L);
	return off+L;
}

 static  void rep_char(char *abuf, int chr,int len) {
	int j;
	for(j=0;j<len;j++)
		abuf[j]=chr;
	abuf[j]= 0;
}

 static  int is_child(char *candidate,char *base) {
	return common(candidate, base, strlen(candidate)) == strlen(base);
}


