

#include "stdlib.h"

#include "utf8.h"

 static  int
convert(unsigned char *str,int len, wchar_t* B) ; static  int
leading_bits(unsigned char X) ;

#define  BIT31   (1u<<31u)

static const unsigned
utf8_ranges[]=  {
0x00000000, 0x0000007F,
0x00000000, 0x00000000,
0x00000080, 0x000007FF,
0x00000800, 0x0000FFFF,
0x00010000, 0x001FFFFF,
0x00200000, 0x03FFFFFF,
0x04000000, 0x7FFFFFFF,
0x00000000, 0x00000000,
0x00000000, 0x00000000 };







 wchar_t*
utf8buf2wstr(char *str,int len) {
        int clen;
        wchar_t* R;
        clen= convert((unsigned char*) str,len, 0);
        R= malloc(sizeof(*R)*(len+1));
        clen= convert((unsigned char*) str,len,R);
        R[clen]= 0;
        return R;
}


 static  int
convert(unsigned char *str,int len, wchar_t* B) {
        utf8decoder_t D;
        int i, r, k, L;
        L= 0;
        utf8decoder_init(&D, UTF8_DELETE);
        for(i=0;i<len;i++) {
                r= utf8decoder_chr(&D, str[i]);
                 {
        if (B)
                for(k=0;k<r;k++)
                        B[L+k]= D.outbuf[k];
        L+= r;
}


        }
        r= utf8decoder_end(&D);
         {
        if (B)
                for(k=0;k<r;k++)
                        B[L+k]= D.outbuf[k];
        L+= r;
}


        return L;
}





 void
wchr2utf8str(wchar_t chr,char *out) {
	int L;
	L= utf8encode_chr(chr, out);
	out[L]= 0;
}




 void
utf8decoder_init(utf8decoder_t *dec,int erract) {
	dec->size= 0;
	dec->erract= erract;
}

 int
utf8decoder_chr(utf8decoder_t *dec,unsigned chr) {
	int lb= leading_bits(chr);
	int erract= dec->erract;
	if (!dec->size) 
		
switch(lb) {
	case 0:
		dec->outbuf[0]= chr;
		return dec->outlen= 1;
	case 1:
	case 7:
	case 8:
		 
switch(erract) {
	case UTF8_DELETE:
		return dec->outlen=0;
	case UTF8_REPORT:
		dec->outbuf[0]= BIT31  | chr;
		return dec->outlen=1;
	default:
		dec->outbuf[0]= erract;
		return dec->outlen= 1;
}


	default:
		 {
	dec->size= lb;
	dec->len= 1;
	dec->pbuf[0]= chr;
}


		return dec->outlen=0;
}


	else
		
switch(lb) {
	case 0:
		
switch(erract) {
	case UTF8_DELETE:
		dec->outbuf[0]= chr;
		dec->size= 0;
		return dec->outlen=1;
	case UTF8_REPORT: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= BIT31 | dec->pbuf[i];
}


		dec->outbuf[dec->len]= chr;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
	default: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= erract;
}


		dec->outbuf[dec->outlen]= chr;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
}


	case 1:
		dec->pbuf[dec->len++]= chr;
		if (dec->len==dec->size) 
			 {
	unsigned result= 0;
	unsigned shift= 0;
	 {
	int i;
	for(i=dec->len-1;i>0;i--) {
		unsigned char xes= (dec->pbuf[i]& 
0x3f

);
		result= result | (xes << shift);
		shift+= 6;
	}
}


	 {
	static const unsigned char 
	masks []= { 0,  0,
	
0x1f

,
	
0x0f

,
	
0x07

,
	
0x03

,
	
0x01

, };
	unsigned char xes= dec->pbuf[0] & masks[dec->len];
	result= result | (xes << shift);
}


	 {
	unsigned lo= utf8_ranges[2*dec->len];
	unsigned hi= utf8_ranges[2*dec->len+1];
	if (result<lo || result>hi) { /* don`t know how it could be :) */
		 {
	dec->len--;
	/* they are not the same thing, but they have
	exactly the same actions. so, I`ll let this go for now
	maybe it should be a function ? */
	
switch(erract) {
	case UTF8_DELETE:
		dec->size= 0;
		return dec->outlen=0;
	case UTF8_REPORT: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= BIT31 | dec->pbuf[i];
}


		dec->outbuf[dec->len]= BIT31 | chr;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
	default: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= erract;
}


		dec->outbuf[dec->outlen]= erract;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
}


}

/* we were in the middle of a sequence, another sequence
has now started. */

	}
}

	dec->size= 0;
	dec->outbuf[0]= result;
	return dec->outlen=1;
}


		return dec->outlen=0;
	case 7:
	case 8:
		
switch(erract) {
	case UTF8_DELETE:
		dec->size= 0;
		return dec->outlen=0;
	case UTF8_REPORT: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= BIT31 | dec->pbuf[i];
}


		dec->outbuf[dec->len]= BIT31 | chr;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
	default: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= erract;
}


		dec->outbuf[dec->outlen]= erract;
		dec->size= 0;
		return dec->outlen= dec->len+1;
	}
}


	default:
		 
switch(erract) {
	case UTF8_DELETE:
		 {
	dec->size= lb;
	dec->len= 1;
	dec->pbuf[0]= chr;
}


		return dec->outlen=0;
	case UTF8_REPORT: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= BIT31 | dec->pbuf[i];
}


		dec->outlen= dec->len;
		 {
	dec->size= lb;
	dec->len= 1;
	dec->pbuf[0]= chr;
}


		return dec->outlen;
	}
	default: {
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= erract;
}


		dec->outlen= dec->len;
		 {
	dec->size= lb;
	dec->len= 1;
	dec->pbuf[0]= chr;
}


		return dec->outlen;
	}
}


}




}

 int
utf8decoder_end(utf8decoder_t *dec) {
	if (dec->size) 
		 {
int erract= dec->erract;
switch(erract) {
	case UTF8_DELETE:
		return dec->outlen=0;
	case UTF8_REPORT:
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= BIT31 | dec->pbuf[i];
}


		return dec->outlen= dec->len;
	default:
		 {
	int i;
	for(i=0;i<dec->len;i++)
		dec->outbuf[i]= erract;
}


		return dec->outlen= dec->len;
}}

	else
		return dec->outlen= 0;
}

 static  int
leading_bits(unsigned char X) {
	static const unsigned char
	lead_bits[]= { 0,
		
0x80

,
		
0xc0

,
		
0xe0

,
		
0xf0

,
		
0xf8

,
		
0xfc

,
		
0xfe

,
		
0xff

, };
	int i;
	for(i=8;i>=0;i--)
		if ((lead_bits[i] & X) == lead_bits[i])
			return i;
	return 0;
}










/*
  This is all from
  http://www.cl.cam.ac.uk/~mgk25/unicode.html

  TODO: what to do if the input has invalid
  unicode chars such as unassigned chars etc?
  pass them thru?
*/

 int
utf8encode_chr(unsigned chr,unsigned char *dst) {
	int i,k;
	int len;
	static const unsigned int
	lowerlimit[]= {
		0x04000000,
		0x00200000,
		0x00010000,
		0x00000800,
		0x00000080 };
	static const unsigned char 
	topbits []= {
		
0xfc

,
		
0xf8

,
		
0xf0

,
		
0xe0

,
		
0xc0

,
	};
	if (chr<=0x7f) {
		dst[0]= chr;
		return 1;
	}
	if (chr & BIT31) {
		dst[0]= chr & ~BIT31;
		return 1;
	}
	for(i=0;i<4;i++)
		if (chr >= lowerlimit[i])
			break;
	len= 4-i+2;
	const unsigned char lower6= 
0x3f

;
	const unsigned char seventh= 
0x80

;
	for(k=len-1;k>0;k--) {
		dst[k]= seventh | (chr & lower6);
		/* unsigned shift is a wonderful device */
		chr >>= 6;
	}
	dst[k]= chr | topbits[i];
	return len;
}
