
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <stdlib.h>
#include <string.h>
#include "docparse.h"
#include "parser.h"

#include "search.h"
typedef struct strbuf strbuf_t;
struct strbuf
{
  struct strbuf *prev, *next;
  char data[4084];
  int len;
};
typedef struct
{
  page_t *page;
  char *title;
  char *tags;
} entry_t;
struct selist_t_NODE
{
  struct selist_t_NODE *prev, *next;
  entry_t *data;
};
typedef struct
{
  struct selist_t_NODE head;
} selist_t;
static void sbprintf (strbuf_t * sb, char *fmt, ...);
static void sbputs (strbuf_t * sb, char *str);
static void sbputs_l (strbuf_t * sb, char *str, int len);
static strbuf_t *strbuf_init ();
static char *strbuf_collect (strbuf_t * sb);
static int sb_collect (strbuf_t * sb, char *dst);
static void sb_free (strbuf_t * sb);
static void selist_init (selist_t * L);
static entry_t *selist_destroy (selist_t * L);
static selist_t *selist_new ();
static void selist_append (selist_t * L, entry_t * data);
static void selist_prepend (selist_t * L, entry_t * data);
static void selist_remove (selist_t * L, struct selist_t_NODE *n);
static int selist_isempty (selist_t * L);
static void ignore_bullet (void *a1, int a2);
static void ignore_pbreak (void *a1);
static void ignore_text (void *a1, int a2, char *a3, int a4);
static void ignore_formatted (void *a1, char *a2, int a3);
static void ignore_link (void *a1, int k, char *v, int l);
static void try_match (selist_t * ret, page_t * page, char *expr);
static void check_header (void *a1, int level, char *str, int len);
static void check_tag (void *sink, char *tag);
static int get_arg
  (char *expr, char *op, char **begin, char **end, char *res);
static void replace (char *begin, char *end, char *rep);
static int compact (char *expr);
static int subs (char *dst, char *exp, char *res);
static int eval_expr (char *expr);

static void
lsort_10 (selist_t * list)
{
  typeof (list->head.next) pivot, iter;
  typeof (list[0]) glist;

  if (list->head.next == list->head.prev)
    return;

  glist.head.prev = glist.head.next = &glist.head;
  pivot = list->head.prev;
  {
    (pivot)->prev->next = (pivot)->next;
    (pivot)->next->prev = (pivot)->prev;

    (pivot)->prev = (pivot);
    (pivot)->next = (pivot);

  }

  {
    void *N83;
    for (iter = (&list->head)->next; iter != (&list->head); iter = N83)
      {
	N83 = iter->next;

	int result = -1;
	typeof (list->head.data) E1, E2;
	E1 = iter->data;
	E2 = pivot->data;

	result = strcmp (E1->title, E2->title);

	if (result > 0)
	  {
	    {
	      (iter)->prev->next = (iter)->next;
	      (iter)->next->prev = (iter)->prev;

	      (iter)->prev = (iter);
	      (iter)->next = (iter);

	    }

	    {
	      (iter)->prev = ((&glist.head))->prev;
	      (iter)->next = ((&glist.head));
	      ((&glist.head))->prev->next = (iter);
	      ((&glist.head))->prev = (iter);
	    }

	  }

      }
  }

  lsort_10 (list);
  lsort_10 (&glist);
  {
    (pivot)->prev = ((&list->head))->prev;
    (pivot)->next = ((&list->head));
    ((&list->head))->prev->next = (pivot);
    ((&list->head))->prev = (pivot);
  }

  {
    void *N88;
    for (iter = (&glist.head)->next; iter != (&glist.head); iter = N88)
      {
	N88 = iter->next;

	{
	  (iter)->prev->next = (iter)->next;
	  (iter)->next->prev = (iter)->prev;

	  (iter)->prev = (iter);
	  (iter)->next = (iter);

	}

	{
	  (iter)->prev = ((&list->head))->prev;
	  (iter)->next = ((&list->head));
	  ((&list->head))->prev->next = (iter);
	  ((&list->head))->prev = (iter);
	}

      }
  }

}

static char query[200];
static char page_title[2000];
static int page_title_level;
static char page_tags[2000];

void *__unused_search_c[] = {

  (void *) selist_prepend,

  (void *) selist_init,

  0,
};

static void
sbprintf (strbuf_t * sb, char *fmt, ...)
{
  char *raw;
  va_list ap;
  va_start (ap, fmt);
again:
  for (raw = fmt; raw[0]; raw++)
    if (raw[0] == '%')
      break;
  if (raw != fmt)
    sbputs_l (sb, fmt, raw - fmt);
  if (raw[0] == 0)
    goto ende;
  switch (raw[1])
    {
    case 0:
      sbputs (sb, "%");
      goto ende;
    case 'd':
      {
	char buf[40];
	int arg = va_arg (ap, int);
	sprintf (buf, "%d", arg);
	sbputs (sb, buf);
	break;
      }
    case 's':
      {
	char *arg = va_arg (ap, char *);
	sbputs (sb, arg);
	break;
      }
    default:
      sbputs_l (sb, raw + 1, 1);
      break;
    }
  fmt = raw + 2;
  goto again;
ende:
  va_end (ap);
}

static void
sbputs (strbuf_t * sb, char *str)
{
  sbputs_l (sb, str, strlen (str));
}

static void
sbputs_l (strbuf_t * sb, char *str, int len)
{
  while (len)
    {
      strbuf_t *t;
      int cp;
      t = sb->prev;
      cp = sizeof (t->data) - t->len;
      if (cp > len)
	cp = len;
      if (cp == 0)
	{

	  t = (typeof (t)) calloc (1, sizeof (t[0]));

	  t->len = 0;
	  {
	    (t)->prev = (sb)->prev;
	    (t)->next = (sb);
	    (sb)->prev->next = (t);
	    (sb)->prev = (t);
	  }

	  continue;
	}
      memcpy (t->data + t->len, str, cp);
      str += cp;
      len -= cp;
      t->len += cp;
    }
}

static strbuf_t *
strbuf_init ()
{
  strbuf_t *t;

  t = (typeof (t)) calloc (1, sizeof (t[0]));

  t->len = 0;
  t->prev = t->next = t;
  return t;
}

static char *
strbuf_collect (strbuf_t * sb)
{
  int l;
  char *k;
  l = sb_collect (sb, 0);
  k = malloc (l + 1);
  sb_collect (sb, k);
  k[l] = 0;
  sb_free (sb);
  return k;
}

static int
sb_collect (strbuf_t * sb, char *dst)
{
  strbuf_t *k;
  int L;
  k = sb;
  L = 0;
  do
    {
      if (dst)
	memcpy (dst + L, k->data, k->len);
      L += k->len;
      k = k->next;
    }
  while (k != sb);
  return L;
}

static void
sb_free (strbuf_t * sb)
{
  while (sb->prev != sb)
    {
      strbuf_t *t = sb->prev;
      sb->prev = t->prev;
      free (t);
    }
  free (sb);
}

static void selist_init (selist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

static entry_t *selist_destroy (selist_t * L)
{
  typeof (L->head.next) N;
  entry_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  selist_remove (L, N);
  return R;
}

static selist_t *selist_new ()
{
  selist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

static void selist_append (selist_t * L, entry_t * data)
{
  struct selist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

static void selist_prepend (selist_t * L, entry_t * data)
{
  struct selist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

static void selist_remove (selist_t * L, struct selist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

static int selist_isempty (selist_t * L)
{
  return L->head.next == &L->head;
}

char *
search_tags (page_t * L, char *expr)
{
  page_t *p;
  selist_t *ser;
  strbuf_t *rbuf;

  ser = selist_new ();
  {
    void *N8;
    for (p = L->next; p != L; p = N8)
      {
	N8 = p->next;

	try_match (ser, p, expr);

      }
  }

  if (selist_isempty (ser))
    {
      char buf[2000];
      free (ser);
      sprintf (buf, "=== Search Results ===\n\n"
	       "The expression '%s' did not match any of the "
	       "pages.\n", expr);
      return strdup (buf);
    }

  lsort_10 (ser);

  rbuf = strbuf_init ();
  sbprintf (rbuf, "=== Search Results ===\n\n");
  sbprintf (rbuf, "Search Expression= '%s'\n\n", expr);
  while (!selist_isempty (ser))
    {
      entry_t *E = selist_destroy (ser);
      sbprintf (rbuf, "+ X<%s>L<%s> : %s\n",
		E->page->name, E->title, E->tags);
      free (E->title);
      free (E->tags);
      free (E);
    }
  sbprintf (rbuf, "+ \n");
  return strbuf_collect (rbuf);
}

static void
ignore_bullet (void *a1, int a2)
{
}

static void
ignore_pbreak (void *a1)
{
}

static void
ignore_text (void *a1, int a2, char *a3, int a4)
{
}

static void
ignore_formatted (void *a1, char *a2, int a3)
{
}

static void
ignore_link (void *a1, int k, char *v, int l)
{
}

static void
try_match (selist_t * ret, page_t * page, char *expr)
{
  entry_t *E;

  parser_sink_t sink;

  sink.bullet = ignore_bullet;
  sink.pbreak = ignore_pbreak;
  sink.link = ignore_link;
  sink.text = ignore_text;
  sink.formatted = ignore_formatted;
  sink.header = check_header;
  sink.tag = check_tag;

  strcpy (query, expr);
  page_tags[0] = 0;
  page_title_level = 100;
  page_title[0] = 0;
  parse_doc (page->text, &sink);

  {
    char *begin, *end;
    char tag[200];
    end = query;
    while (get_arg (end, "t!", &begin, &end, tag))
      replace (begin, end, "1");
    end = query;
    while (get_arg (end, "t=", &begin, &end, tag))
      replace (begin, end, "0");
  }

  if (!eval_expr (query))
    return;

  E = (typeof (E)) calloc (1, sizeof (E[0]));

  E->page = page;
  if (page_title[0])
    E->title = strdup (page_title);
  else
    E->title = strdup (page->name);
  if (page_tags[0])
    E->tags = strdup (page_tags);
  else
    E->tags = strdup ("");
  selist_append (ret, E);
}

static void
check_header (void *a1, int level, char *str, int len)
{
  if (page_title_level <= level)
    return;
  memcpy (page_title, str, len);
  page_title[len] = 0;
  page_title_level = level;
}

static void
check_tag (void *sink, char *tag)
{
  char t[200];
  strcat (page_tags, tag);
  strcat (page_tags, " ");

  sprintf (t, "!%s", tag);
  while (subs (query, t, "0"))
    ;
  sprintf (t, "=%s", tag);
  while (subs (query, t, "1"))
    ;
}

static int get_arg (char *expr, char *op, char **begin, char **end, char *res)
{
  int i;
  char *s;
  char *d;
  s = strstr (expr, op);
  if (!s)
    return 0;
  *begin = s;
  d = s + strlen (op);
  for (i = 0; d[i]; i++)
    if (d[i] == ')' || d[i] == '&' || d[i] == '|')
      break;
  *end = d + i;
  for (s = d; s < *end; s++)
    *(res++) = *s;
  *res = 0;
  return 1;
}

static void
replace (char *begin, char *end, char *rep)
{
  int len;
  len = strlen (rep);
  memcpy (begin, rep, len);
  for (begin = begin + len; begin < end; begin++)
    *begin = ' ';
}

static int
compact (char *expr)
{
  int i;
  int j = 0;
  for (i = 0; expr[i]; i++)
    if (expr[i] != ' ')
      expr[j++] = expr[i];
  expr[j] = 0;
  return i != j;
}

static int
subs (char *dst, char *exp, char *res)
{
  char *s;
  int i;
  s = strstr (dst, exp);
  if (!s)
    return 0;
  for (i = 0; res[i] && exp[i]; i++)
    s[i] = res[i];
  for (; exp[i]; i++)
    s[i] = ' ';
  compact (dst);
  return 1;
}

/* ohoho */
static int
eval_expr (char *expr)
{
  int change;
  do
    {
      change = 0;
      while (subs (expr, "0&0", "0"))
	change++;
      while (subs (expr, "0&1", "0"))
	change++;
      while (subs (expr, "1&0", "0"))
	change++;
      while (subs (expr, "1&1", "1"))
	change++;
      while (subs (expr, "0|0", "0"))
	change++;
      while (subs (expr, "0|1", "1"))
	change++;
      while (subs (expr, "1|0", "1"))
	change++;
      while (subs (expr, "1|1", "1"))
	change++;
      while (subs (expr, "(0)", "0"))
	change++;
      while (subs (expr, "(1)", "1"))
	change++;
      while (subs (expr, "!0", "1"))
	change++;
      while (subs (expr, "!1", "0"))
	change++;
      if (compact (expr))
	change++;
      if (expr[1] == 0)
	return expr[0] == '1';
    }
  while (change);
  return 0;
}
