
#include <fx.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include "xtview.h"



 void
init_display(int argc,char **argv) ; void run_gui() ; void
file_read_all(char *fn,char **buf,int *len) ;



 static  FXMainWindow*
create_toplevel() ; static  void handle_link(int linkid) ;
 static  xtview_t *view; static  FXMainWindow *main_window;

     
     
     	
	     /* declaration for the page title font goes here */
     	
     class MyFoxApp : public FXApp {
	     FXDECLARE(MyFoxApp)
	     public:
	     	enum {
			     ID_FIRSTCMD= FXApp::ID_LAST,
			     
	        };
		public:
		      
		      MyFoxApp(const FXString &name, const FXString &vendor) 
		      	: FXApp(name, vendor) { }
			MyFoxApp() : FXApp() { }
		            
     };
     FXDEFMAP(MyFoxApp)  MyFoxAppMap[]= {
	     
    };
    FXIMPLEMENT(MyFoxApp, FXApp, 
    	MyFoxAppMap, ARRAYNUMBER(MyFoxAppMap))
    static MyFoxApp *foxapp;
 







 static  FXMainWindow*
create_toplevel() {
	FXMainWindow *ret;
	 
      FXComposite *parent;
      int common_options= 0;


	 {
	FXMainWindow *obj;
	FXComposite *prior;
	int _width=0, _height= 0;
	
          _width= 600; _height= 600;
   
	obj= new FXMainWindow(foxapp,
		"HELLO!!", NULL, NULL, DECOR_ALL,
		0, 0, _width, _height);
	
	prior= parent;
	parent=obj;


		
   


		
		view= new xtview_t( parent, LAYOUT_FILL_X | LAYOUT_FILL_Y );
		view->link_handler= handle_link;
		ret= obj;
	 parent= prior; }



	 
	

	return ret;
}

 static  void handle_link(int linkid) {
	printf("Link: %d\n",linkid);
}

static doc_style_t document_styles[]= {
	{ 'D', "Bitstream Vera Sans" , 12, 0, 0, 0 },
	{ 'R', "Bitstream Vera Sans" , 12, 0, 0, 0xff0000 },
	{ 'G', "Bitstream Vera Sans" , 12, 0, 0, 0x438c18 },
	{ 'B', "Arial" , 12, 'B', 0, 0 },
	{ 'I', "Bitstream Vera Sans" , 12, 0, 'I', 0 },
	{ 'L', "Bitstream Vera Sans" , 12, 0, 0, 0xff },
	{ 'C', "Courier New", 12, 0, 0, 0 },
	{ 'F', "Courier New", 12, 0, 0, 0},
	{ '1', "Bitstream Vera Sans", 18, 'B', 0, 0 },
	{ '2', "Bitstream Vera Sans", 17, 'B', 0, 0 },
	{ '3', "Bitstream Vera Sans", 15, 'B', 0, 0 },
	{ '4', "Bitstream Vera Sans", 14, 'B', 0, 0 },
	{ 0, 0, 0, 0 , 0 , 0 }
};


 void
init_display(int argc,char **argv) {
	
	
 
  foxapp= new MyFoxApp("Test", "BlackSys");
  foxapp->init(argc,argv);


	main_window= create_toplevel();
	xtview_set_styles( foxapp, document_styles );
	foxapp->create();
	main_window->show(PLACEMENT_SCREEN);
}

 void run_gui() { foxapp->run(); }

int main(int argc,char** argv) {
	init_display(argc,argv);
	char *buf;
	int len;
	file_read_all(argv[1], &buf, &len);
	view->set_text(buf);
	free(buf);
	run_gui();
	return 0;
}









 void
file_read_all(char *fn,char **buf,int *len) {
	size_t L;
	struct stat sb;
	FILE *f;
	if (stat(fn,&sb))
		exit(fprintf(stderr,"can not stat %s: %s\n",
			fn,strerror(errno)));
	f= fopen(fn,"rb");
	if (!f)
		exit(fprintf(stderr,"can not open %s: %s\n",
			fn,strerror(errno)));
	L= sb.st_size;
	*len= 0;
	*buf= (char*) malloc(L+1);
	while((size_t)*len<L) {
		size_t r= fread(*buf + *len, 1, L-*len, f);
		if (!r)
			exit(fprintf(stderr,"can not read %s: %s\n",
				fn,strerror(errno)));
		*len += r;
	}
	(*buf)[L]= 0;
	fclose(f);
}
