

#ifndef SCTVIEW_H
#define SCTVIEW_H

#ifndef FXSCROLLARAEA_H
#include <FXScrollBar.h>
#include <FXScrollArea.h>
#endif
#include "styles.h" 
#include "layout.h"

namespace FX {

	
class FXAPI xtview_t : public FXScrollArea {
	FXDECLARE(xtview_t)
protected:
	xtview_t();
private:
	xtview_t(const xtview_t&);
	xtview_t &operator=(const xtview_t&);
	text_part_t *parts;
	int nparts;

	int cont_width;
	int cont_height;
	int cont_x;
	int cont_y;
	char *buffer;
public:
	long onPaint(FXObject*,FXSelector,void*);
	long onLeftBtnPress(FXObject*,FXSelector,void*);
	long onKeyPress(FXObject*,FXSelector,void*);

	xtview_t(FXComposite* p,
		FXuint opts=FRAME_NORMAL,
		FXint x=0,FXint y=0,FXint w=0,FXint h=0);
	virtual ~xtview_t();

	virtual bool canFocus() const;
	virtual void create();
	virtual void detach();

	virtual int getDefaultWidth();
	virtual int getDefaultHeight();
	virtual int getContentWidth();
	virtual int getContentHeight();

	void set_text(char *buf);
	void layout_buffer();

	virtual void layout();
	void (*link_handler)(int lnkid);
};

}


 void xtview_set_styles(FX::FXApp *app,doc_style_t *doc_styles) ; int rect_subtract(int *a,int *b,int *out) ;


#endif

