-[ c library "display.cc", header "display.h" ]

-[ header "fx.h" ]
-[ lheader "xtview.h" ]
-[ lheader "main.h" ]


-[private] void create_toplevel() {
	-[ begin FOX gui description ]
	-[ toplevel "HELLO!!" , begin ]
		-[ default size= 600 x 600 ]
		-[private] FXMainWindow *main_window;
		main_window= obj;
	-[ end ]
	-[ end FOX gui description ]
}

-[private] void show_viewing_screen() {
	if (screen) delete screen;
	-[ begin FOX gui description ]
	parent= main_window;
	-[ vbox, begin] -[fill-x] -[fill-y]
		-[ hbox, begin ] -[fill-x]
			-[ edit button ]
			-[ file buttons]
			-[ exit button ]
		-[ end ]
		-[ hbox, begin ] -[ fill-x ]
			-[ history buttons ]
			-[ navigation buttons ]
		-[ end ]
		-[ hbox, begin] -[fill-x]
			-[ label2 "PAGE TAGS: ", begin ]
				-[ font size= 120 ]
			-[end]
			-[ label2 "", begin ]
				-[ font size= 120 ]
				-[private] FXLabel *tags_label;
				tags_label= obj;
			-[ end ]
			-[ button, begin ]
				-[ label "ARA" ]
				-[ pack right ]
				-[ code begin ]
					do_tag_search
					(strdup(tsearch_entry->getText().text()));
				-[ code end ]
			-[ end ]
			-[ string entry, begin ]
				-[ pack right ]
				-[ #columns = 30 ]
				-[ code begin ]
					do_tag_search(strdup(str));
				-[ code end ]
				-[ private] FXTextField *tsearch_entry;
				tsearch_entry= obj;
			-[ end ]
		-[end]
		-[ the document viewer ]
		-[ private] FXComposite *screen;
		screen= obj;
	-[end]
	-[ end FOX gui description ]
}

-[public] void reset_tag_display() {
	tags_label->setText("");
}

-[public] void add_page_tag(char *str) {
	FXString s;
	s= tags_label->getText();
	s.append(" ");
	s.append(str);
	tags_label->setText(s);
}

-[private] void show_editing_screen() {
	if (screen) delete screen;
	-[ begin FOX gui description ]
	parent= main_window;
	-[ vbox, begin ]
		-[ fill-x] -[fill-y]
		-[hbox, begin ] -[fill-x]
			-[ save button ]
		-[ end ]
		-[ textarea, begin ]
			-[ fill-x ] -[fill-y]
			-[ word-wrap ]
			-[private] FXText *edit_area;
			edit_area= obj;
		-[ end ]
		screen= obj;
	-[ end ]
	-[ end FOX gui description]
}



static doc_style_t document_styles[]= {
	{ 'D', "Bitstream Vera Sans" , 12, 0, 0, 0 },
	{ 'R', "Bitstream Vera Sans" , 12, 0, 0, 0xff0000 },
	{ 'G', "Bitstream Vera Sans" , 12, 0, 0, 0x438c18 },
	{ 'B', "Arial" , 12, 'B', 0, 0 },
	{ 'I', "Bitstream Vera Sans" , 12, 0, 'I', 0 },
	{ 'L', "Bitstream Vera Sans" , 12, 0, 0, 0xff },
	{ 'C', "Courier New", 12, 0, 0, 0 },
	{ 'F', "Courier New", 12, 0, 0, 0},
	{ '1', "Bitstream Vera Sans", 18, 'B', 0, 0 },
	{ '2', "Bitstream Vera Sans", 17, 'B', 0, 0 },
	{ '3', "Bitstream Vera Sans", 15, 'B', 0, 0 },
	{ '4', "Bitstream Vera Sans", 14, 'B', 0, 0 },
	{ 0, 0, 0, 0 , 0 , 0 }
};



-[public] void run_gui() { foxapp->run(); }

=[ history buttons ]
-[ button, begin ] -[ label "<Geri" ] -[ code begin ]
	move_back();
-[ code end ] -[ end ]
-[ label2 "", begin ] -[ font size= 120 ]
	-[private] FXLabel *title_label;
	title_label= obj;
-[ end ]
-[ button, begin ] -[ label "İleri>" ] -[ code begin ]
	move_forward();
-[ code end ] -[ end ]

=[]

-[public] void display_text(char *pname,char *txt) {
	if (page_name)
		free(page_name);
	page_name= strdup(pname);
	if (page_text)
		free(page_text);
	page_text= strdup(txt);
	view->set_text(txt);
	title_label->setText(pname);
}

=[ edit button ]
-[ button, begin ]
	-[ label "Değiştir" ]
	-[ code begin ]
		show_editing_screen();
		screen->create();
		main_window->recalc();
		edit_area->setText(page_text);
	-[ code end ]
-[end ]

=[ save button ]
-[ button, begin ] -[ label "Kaydet" ] -[ code begin ]
	char *txt= strdup(edit_area->getText().text());
	show_viewing_screen();
	screen->create();
	save_page(page_name, txt);
	free(txt);
-[ code end ] -[end ]

-[ label2 "Sayfayı", begin ] -[font size=120] -[end]

-[ button, begin ] -[label "İptal"] -[code begin ]
	show_viewing_screen();
	screen->create();
	view->set_text(page_text);
	reset_tag_display();
	display_tags(page_text);
-[ code end] -[end]

=[ file buttons ]
-[ label2 " / ", begin ] -[ font size= 140 ] -[ end ]
-[ button, begin ] -[label "Aç" ] -[code begin ]
	char *fname;
	fname= choose_file("Dosya -> Program");
	if (!fname)
		return 1;
	load_file(fname);
	free(fname);
-[ code end ] -[end]
-[ label2 "Dosya", begin] -[font size=120] -[end]
-[ button, begin ] -[label "Farklı"] -[code begin ]
	char *fname;
	fname= choose_file("Program -> Dosya");
	if (!fname)
		return 1;
	save_file(fname);
	free(fname);
-[ code end] -[end]
-[ button, begin ] -[label "Kaydet"] -[code begin ]
	char *fname;
	fname= get_file_name();
	if (!fname) {
		fname= choose_file("Program -> Dosya");
		if (!fname)
			return 1;
	}
	save_file(fname);
-[ code end] -[end]

=[ the document viewer ]
	-[private] xtview_t *view;
	view= new xtview_t( parent, LAYOUT_FILL_X | LAYOUT_FILL_Y );
	view->link_handler= follow_link;

=[]

-[public] void
init_display(char *pname,char *ptext) {
	int argc= 1;
	-[private] char *page_name;
	-[private] char *page_text;
	char *argv[]= { "txar", 0 };
	-[ fox application : vendor = "BlackSys", program = "Test" ]
	create_toplevel();
	show_viewing_screen();
	xtview_set_styles( foxapp, document_styles );
	foxapp->create();
	main_window->show(PLACEMENT_SCREEN);
	display_text(pname,ptext);
}

-[private] char *choose_file(char *title) {
	FXFileDialog *dlg;
	char *fname=0;
	dlg= new FXFileDialog(main_window, title);
	if (dlg->execute()) 
		fname= strdup(dlg->getFilename().text());
	delete dlg;
	return fname;
}

=[ exit button ]
-[ button, begin ] -[label "Çık"] -[ pack right ]
-[code begin]
	char *fname;
	fname= get_file_name();
	if (!fname) 
		fname= choose_file("Program -> Dosya");
	if (fname)
		save_file(fname);
	exit(0);
-[code end] -[end]

=[ navigation buttons ]
-[ label2 " / ", begin ] -[ font size= 140 ] -[ end ]
-[ button, begin ] -[label "Yukarı" ]
-[ code begin ]
-[ code end ] -[end]

-[ button, begin ] -[label "İçindekiler" ]
-[ code begin ]
	display_toc();
-[ code end ] -[end]


=[]

+[ application method definitions ]
long onCmdQuit(FXObject * object, FXSelector sel, void *arg) {
	do_quit();
	return 1;
}
+[ end ]
+[ application command bindings ]
	FXMAPFUNC (SEL_COMMAND, MyFoxApp::ID_QUIT,
	     MyFoxApp::onCmdQuit),
+[ end ]
