-[ c library "docparse.c", header "docparse.h" ]

-[public] typedef struct page {
	struct page *prev,*next;
	char *name;
	char *text;
} page_t;


-[public] page_t *read_doc(char *fn) {
	FILE *f;
	page_t *head;
	f= fopen(fn,"rb");
	if (!f)
		return 0;
	-[ allocate object head ]
	head->prev= head->next= head;

	while(1) {
		char hdr[2000];
		int sz;
		char name[2000];
		page_t *p;
		if (!fgets(hdr, 2000, f))
			break;
		sscanf(hdr,"%d%s",&sz, name);
		-[ allocate object p ]
		p->text= read_bytes(f, sz);
		p->name= strdup(name);
		-[clist/insert p before head ]
	}
	fclose(f);
	return head;
}

-[private] char *read_bytes(FILE *f,int sz) {
	char *buf;
	int L;
	
	buf= malloc(sz+1);
	for(L=0;L<sz;) {
		int r= fread(buf+L, 1, sz-L,f);
		if (r<=0)
			break;
		L+= r;
	}
	buf[L]= 0;
	return buf;
}

-[public] int save_doc(char *fn,page_t *head) {
	FILE *f;
	page_t *p;
	f= fopen(fn,"wb");
	if (!f)
		return 1;
	-[ for each p in list head, begin ]
		fprintf(f, "%d %s\n%s",strlen(p->text), p->name,p->text);
	-[ end ]
	fclose(f);
	return 0;
}

-[ header "stdlib.h" ] -[ header "stdio.h" ] -[ header "string.h" ]
