-[ header "sys/types.h" ]
-[ header "sys/stat.h" ]
-[ header "stdio.h" ]
-[ header "string.h" ]
-[ header "errno.h" ]
-[ header "stdlib.h" ]


-[public] void
file_read_all(char *fn,char **buf,int *len) {
	size_t L;
	struct stat sb;
	FILE *f;
	if (stat(fn,&sb))
		exit(fprintf(stderr,"can not stat %s: %s\n",
			fn,strerror(errno)));
	f= fopen(fn,"rb");
	if (!f)
		exit(fprintf(stderr,"can not open %s: %s\n",
			fn,strerror(errno)));
	L= sb.st_size;
	*len= 0;
	*buf= (char*) malloc(L+1);
	while((size_t)*len<L) {
		size_t r= fread(*buf + *len, 1, L-*len, f);
		if (!r)
			exit(fprintf(stderr,"can not read %s: %s\n",
				fn,strerror(errno)));
		*len += r;
	}
	(*buf)[L]= 0;
	fclose(f);
}
