-[ program "layout-test.c" ]

-[ lheader "layout.h" ]
-[ lheader "sfont.h" ]

#define WIDTH 400


int main(int argc,char **argv) {
	char *cbuf;
	int clen;
	layout_metrics_t m;

	text_part_t *parts;
	int tlen;

	file_read_all(argv[1],&cbuf,&clen);
	m.page_width= WIDTH;
	m.font_metrics= font_metrics;
	m.text_style= text_style;
	m.bullet_chr= '+';
	m.bullet_indent= bullet_indent;
	m.paragraph_spacing= 10;
	m.tabstop= tabstop;

	-[ calculate font ascent & descent ]

	tlen= layout_doc(cbuf, &m, &parts);

	printf("%d items layed out\n", tlen);
	draw_text(parts, tlen);
	return 0;
}

-[private] int tabstop(layout_metrics_t *m, int x) {
	int i;
	for(i=0;i*50<=x;i++)
		;
	return i*50;
}

-[private] int bullet_indent(layout_metrics_t *m,int level) {
	return level*50;
}


-[private] void font_metrics(layout_metrics_t *m,
		int style,wchar_t chr,
		int *ascent, int *descent, int *width) {
	fbitmap_t *b;
	b= sfont_get(chr);
	*ascent= font_ascent;
	*descent= font_descent;
	*width= b->width;
}

-[private] int text_style(layout_metrics_t *m,int dstyle) {
	return 0;
}

-[private] void draw_text(text_part_t *parts,int plen) {
	FILE *f;
	int last_y= parts[plen-1].y;
	int i;
	-[ private] int image_height;
	-[ private] int image_width;
	-[private] char *image;
	image_height= last_y + font_ascent+font_descent;
	image_width= WIDTH;
	-[ image= allocate array image_width*image_height*3 ]
	memset(image, 0xff, image_width*image_height*3 );

	for(i=0;i<plen;i++)
		draw_text_part(parts+i);

	f= fopen("out.ppm", "wb");
	fprintf(f, "P6\n%d %d\n255\n", image_width,image_height);
	fwrite(image, 1, image_width*image_height*3, f);
	fclose(f);
	free(image);
}

-[private] void draw_text_part(text_part_t *P) {
	int x;
	int i;
	x= P->x;
	for(i=0;P->d.text.text[i];i++) {
		/* for testing I will use only ascii chars so
		this is safe */
		x= draw_char(P->d.text.text[i], x, P->y, P->d.text.ascent);
	}
}


-[private] int draw_char(int chr, int xoff,int ytop,int rascent) {
	int ybase;
	int y0;
	fbitmap_t *b;
	int i,j;

	ybase= ytop+rascent;
	b= sfont_get(chr);

	y0= ybase - b->ascent;

	for(i=0;i<b->width;i++)
		for(j=0;j<b->height;j++) 
			set_pixel( xoff + i, y0+j, b->data[j*b->width+i] );
		
	return xoff+b->width;
}

-[private] void set_pixel(int x,int y, unsigned val) {
	char *p;
	if (x<0 || x>=image_width)
		return ;
	if (y<0 || y>=image_height)
		return ;
	p= image + y*image_width*3 + x*3;
	p[0]= ~val & 0xff;
	p[1]= ~val & 0xff;
	p[2]= ~val & 0xff;
}


=[ calculate font ascent & descent ]
	-[private] int font_ascent;
	-[private] int font_descent; {
		int i;
		for(i=' ';i<127;i++)  {
			fbitmap_t *b= sfont_get(i);
			int d;
			if (b->ascent>font_ascent)
				font_ascent= b->ascent;
			d= b->height-b->ascent;
			if (d>font_descent)
				font_descent= d;
		}
		
	}
=[]
