-[ c library "parser.c", header "parser.h" ]

-[ public ] struct  parser_sink {
	void (*bullet)(void*,int);
	void (*pbreak)(void*);
	void (*link)(void *,int,char *,int);
	void (*text)(void *,int,char *,int);
	void (*formatted)(void *,char *,int);
	void (*header)(void *,int,char *,int);
	void (*tag)(void *,char*);
} ;

-[private] void output_bullet_pbreak(parser_t *p,int d)
	{ (*p->sink->bullet)(p->sink, d); }
-[private] void output_paragraph_break(parser_t *p) 
	 { (*p->sink->pbreak)(p->sink); }
-[private] void output_link(parser_t *p,int kind, char *s,char *e) 
	{ if (e!=s) (*p->sink->link)(p->sink, kind, s, e-s); }
-[private] void output_text(parser_t *p,int style,char *s,char *e)
	{ if (e!=s) (*p->sink->text)(p->sink, style,s, e-s); }

-[private] void output_preformatted(parser_t *p,char *s,char *e)
	{ if (e!=s) (*p->sink->formatted)(p->sink, s, e-s); }

-[private] void output_header(parser_t *p,int level,char *s,char *e) 
	{ if (e!=s) (*p->sink->header)(p->sink, level,s, e-s); }

-[private] void output_tag(parser_t *p,char *value)
	{ (*p->sink->tag)(p->sink, value); }

-[ header "string.h" ]
-[ header "stdlib.h" ]
