-[ c library "toc.c", header "toc.h" ]
-[ lheader "docparse.h" ]

-[ header "stdlib.h" ]
-[ header "stdio.h" ]
-[ header "string.h" ]

-[public] char *gen_toc(page_t *L) {
	plist_t PL;
	page_t *p;
	char *ret;
	plist_t *e;

	PL.prev= PL.next= &PL;
	-[ for each p in list L, begin ]
		-[ allocate object e ]
		e->name= p->name;
		-[ clist/insert e before (&PL) ]
	-[ end ]
	ret= format_page_list("İçindekiler", &PL);
	-[ for each e in list (&PL) , begin ]
		-[clist/remove e]
		free(e);
	-[ end ]
	return ret;
}


-[private] typedef struct plist {
	struct plist *prev,*next;
	char *name;
} plist_t;

-[private] char *format_page_list(char *title,plist_t *p) {
	char *ret;
	int len;
	-[ create the array ]
	-[ sort the array ]
	len= format_page_array(title, parray, plen, 0, 0);
	ret= malloc(len+1);
	format_page_array(title, parray, plen, ret, 0);
	ret[len]= 0;
	free(parray);
	return ret;
}

=[ create the array ]
	char **parray;
	int plen;
	plen= make_page_array(p, 0);
	-[ parray= allocate array plen ]
	make_page_array(p,parray);

=[ sort the array ]
	-[ quicksort array parray= char* [plen] , begin ]
		-[ compare X1 to X2 ]
			result= strcmp(*X1, *X2);
	-[ end ]
		
=[]

-[private] int make_page_array(plist_t *L,char **buf) {
	plist_t *p;
	int len=0;
	-[ for each p in list L, begin ]
		if (buf)
			buf[len]= p->name;
		len++;
	-[ end ]
	return len;
		
}

-[private] int format_page_array
		(char *title, char **parray,int plen,char *buf,int off)
{
	char tbuf[200];
	sprintf(tbuf,"=== %s ===\n\n", title);
	off= append_buffer(buf, tbuf,off);
	return format_pages(parray, plen, buf, off, 0,0);
}

-[private] int format_pages
		(char **parray,int plen, char *buf,int off, int level,int noff)
{
	int i;
	i= 0;

	while(i<plen) {
		char xbuf[1000];
		char abuf[100];
		int cs,ce;
		cs= i+1;
		if (cs<plen && is_child(parray[cs],parray[i])) {
			int common_pfx= strlen(parray[cs]);
			for(ce=cs;ce<plen;ce++)
				if (is_child(parray[ce], parray[i]))
					common_pfx= common( parray[ce],  parray[cs],
							common_pfx);
				else
					break;
			rep_char(abuf, '+', level+1);

			sprintf(xbuf,"%s X<%s>L<%s>\n", abuf, parray[i],
				get_pfx(parray[i],common_pfx)+noff);
			off= append_buffer(buf,xbuf,off);
			off = format_pages(parray+cs, ce-cs,
				buf, off,
				level+1,  common_pfx+1);
			i= ce;
		} else {
			rep_char(abuf,'+', level+1);
			sprintf(xbuf,"%s X<%s>L<%s>\n", abuf, parray[i], parray[i]+noff);
			off= append_buffer(buf,xbuf,off);
			i++;
		}
	}
	return off;
}


/* a.b.c  a.b.d  -> L(a.b.) */
-[private] int common(char *x1,char *x2,int prev) {
	int i;
	if (strlen(x2)<strlen(x1)) {
		char *t= x2;
		x2= x1;
		x1= t;
	}
	for(i=0;x1[i];i++)
		if (x1[i]!=x2[i])
			break;
	if (x1[i]) 
		while(i && x1[i]!='.') i--;
	if (i<prev)
		return i;
	else
		return prev;
}

/* WARNING: not re-entrant. returns a static buffer */
-[private] char *get_pfx(char *str,int pfx) {
	static char buf[2000];
	memcpy(buf,str,pfx);
	buf[pfx]= 0;
	return buf;
}



-[private] int append_buffer(char *buf,char *val,int off) {
	int L= strlen(val);
	if (buf) 
		memcpy(buf+off, val, L);
	return off+L;
}

-[private] void rep_char(char *abuf, int chr,int len) {
	int j;
	for(j=0;j<len;j++)
		abuf[j]=chr;
	abuf[j]= 0;
}

-[private] int is_child(char *candidate,char *base) {
	return common(candidate, base, strlen(candidate))
			== strlen(base);
}

