-[ program "xtview-test.cc" ]

-[ header "fx.h" ]
-[ lheader "xtview.h" ]


-[private] FXMainWindow*
create_toplevel() {
	FXMainWindow *ret;
	-[ begin FOX gui description ]
	-[ toplevel "HELLO!!" , begin ]
		-[ default size= 600 x 600 ]
		-[private] xtview_t *view;
		view= new xtview_t( parent, LAYOUT_FILL_X | LAYOUT_FILL_Y );
		view->link_handler= handle_link;
		ret= obj;
	-[ end ]
	-[ end FOX gui description ]
	return ret;
}

-[private] void handle_link(int linkid) {
	printf("Link: %d\n",linkid);
}

static doc_style_t document_styles[]= {
	{ 'D', "Bitstream Vera Sans" , 12, 0, 0, 0 },
	{ 'R', "Bitstream Vera Sans" , 12, 0, 0, 0xff0000 },
	{ 'G', "Bitstream Vera Sans" , 12, 0, 0, 0x438c18 },
	{ 'B', "Arial" , 12, 'B', 0, 0 },
	{ 'I', "Bitstream Vera Sans" , 12, 0, 'I', 0 },
	{ 'L', "Bitstream Vera Sans" , 12, 0, 0, 0xff },
	{ 'C', "Courier New", 12, 0, 0, 0 },
	{ 'F', "Courier New", 12, 0, 0, 0},
	{ '1', "Bitstream Vera Sans", 18, 'B', 0, 0 },
	{ '2', "Bitstream Vera Sans", 17, 'B', 0, 0 },
	{ '3', "Bitstream Vera Sans", 15, 'B', 0, 0 },
	{ '4', "Bitstream Vera Sans", 14, 'B', 0, 0 },
	{ 0, 0, 0, 0 , 0 , 0 }
};


-[public] void
init_display(int argc,char **argv) {
	-[ private ] FXMainWindow *main_window;
	-[ fox application : vendor = "BlackSys", program = "Test" ]
	main_window= create_toplevel();
	xtview_set_styles( foxapp, document_styles );
	foxapp->create();
	main_window->show(PLACEMENT_SCREEN);
}

-[public] void run_gui() { foxapp->run(); }

int main(int argc,char** argv) {
	init_display(argc,argv);
	char *buf;
	int len;
	file_read_all(argv[1], &buf, &len);
	view->set_text(buf);
	free(buf);
	run_gui();
	return 0;
}

